///////////////////////////////////////////////////////////////////////////////////////////
// LogFile. 
// V1 = plain text, XML support
// V2 = outfile is HTML
// V3 = Added SQL support..
//
// 
// main entry module for program
////////////////////////////
#include "LogFile.h"

/*
**  Defines
*/
#define IDD_GETGOING 200
#define IDD_GETVARS  201
#define IDD_SET_WAITING_FACE  400
#define IDD_SET_INIT_FACE	401
#define DELAYED_STATUS_WAITING_DRAGNDROP 402
#define DELAYED_POST_RUN_OPS   403
#define IDM_ABOUT 1
#define DRAG_N_DROP 995
#define GREG_VERSION 0

static char *version= "3.11";
// MSVC notes: 
//If changing name, manually edit "WinMain.RC"
//Project\Settings [alt F7] with RC file highlighted, ensure "exclude from build" NOT checked
/*    Ensure the classname appears in properties of the Dialogue Editor Window (see 'classname' box) */
/* CreateDialog() may also fail after editing RESOURCE.H 
...note that these 2:
#define IDD_MAIN                        102
#define IDD_WINMAIN                     102
...want to be the same.  It seems like a conflict, but it isnt.
*/

/*
**  Function Prototypes
*/
long APIENTRY WndProc(HWND,UINT,UINT,LONG);
FILE * FileOpen( HWND   hwnd, char *szpfilename);
void UnWindProgressBar(void);

/*
**  Global Variables
*/
HANDLE save_instance=0;
HWND hWndDialog;
FILE *infPtr = NULL;
HWND hWndProgressBar;
int gQuitMssg=0;
int gInProgress=0;
int SQL_KeyWord_Color=0;
int translate_opaque_strings=0;
int plain_text=0;

/* Locals... */
static HWND hWndProc;
static char szdragdrop[MAX_PATH];

/*------------------------------------------------------------------------------------------
**  WinMain()
*--------------------------------------------------------------------------------------------*/
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine,
    int nCmdShow)
{
MSG msg;
HWND hwnd;
WNDCLASSEX wndclass;
char scrap[25];

static char  *appname ="LogFile";

	if(lpszCmdLine); //bummer, lpszCmdLine unused!  Silence compiler warning

	sprintf(scrap, "%s Vers %s", appname, version);

	save_instance=hInstance;

    if(!hPrevInstance)
	{
		wndclass.cbSize     =	sizeof(WNDCLASSEX);
        wndclass.style		=	CS_HREDRAW|CS_VREDRAW;
        wndclass.lpfnWndProc=	WndProc;
        wndclass.cbClsExtra	=	0;
        wndclass.cbWndExtra	=	DLGWINDOWEXTRA;
        wndclass.hInstance	=	hInstance;
		wndclass.hIcon		=	LoadIcon(hInstance,"IDI_ICON1");
        wndclass.hCursor	=	LoadCursor(NULL,IDC_ARROW);
        wndclass.hbrBackground=	(HBRUSH) (COLOR_BTNSHADOW); // (NULL is transparent!) 
														//(7=black) (2 = deep blue)
        wndclass.lpszMenuName=	NULL;
        wndclass.lpszClassName = appname;
		wndclass.hIconSm    = NULL;
		if(!RegisterClassEx(&wndclass))
		{
			MessageBox(NULL, "Window Registration Failed!", "Error!",
				MB_ICONEXCLAMATION | MB_OK);
			return 0;
		}
    }
    hwnd=CreateDialog(hInstance,MAKEINTRESOURCE(IDD_WINMAIN),0,NULL);
    if(!hwnd)
	{
        MessageBox(NULL,"Could not create window - Appname Issue?","ERROR",MB_OK|MB_ICONSTOP);
        return 1;
    }
    
	hWndDialog=hwnd;
    
	/* add new options to System (taskbar) Menu*/
    {
        HMENU hMenu;
        hMenu=GetSystemMenu(hwnd,FALSE);
        if(hMenu!=NULL)
		{
            EnableMenuItem(hMenu,SC_MAXIMIZE,MF_BYCOMMAND|MF_GRAYED);
            EnableMenuItem(hMenu,SC_SIZE,MF_BYCOMMAND|MF_GRAYED);
            AppendMenu(hMenu,MF_SEPARATOR,0,NULL);
            AppendMenu(hMenu,MF_STRING,IDM_ABOUT,"&About...");
            AppendMenu(hMenu,MF_STRING,IDC_HELP_BUTTON,"&Help...");
        }
    }
    
	// get dialog box initialized
    PostMessage(hwnd,WM_COMMAND,IDD_GETGOING,0L);

	ShowWindow(hwnd,nCmdShow);
	SetWindowText(hwnd, scrap);
	UpdateWindow(hwnd);


	// Next is Useful for repeated compiling-then-testing of one default file...commented out for release.
	// PostMessage(hwnd,WM_COMMAND, IDD_LOAD_DEFAULT_FILE, DRAG_N_DROP);

    while(GetMessage(&msg,NULL,0,0))
	{
		switch(msg.message)
		{
			case WM_SYSKEYDOWN:
				switch (msg.wParam) 
				{
					case VK_F4:
						DestroyWindow(hwnd);
					break;
				}
				break;

			//fall thru....
			case WM_KEYDOWN:

				switch (msg.wParam) 
				{
					/* Play with Control keys ... future feature space here */
					case 'O': //control O ?
					break;

					case VK_F12:
						MessageBox( hwnd, "With God, all things are possible.", "Info", MB_OK ); //it works
					break;

					/* I like the ESC key exit option...even tho most folks don't know it's there...
					** uncomment this section to prevent it...
					case VK_ESCAPE:					// Prevent exit on ESC key
						GetMessage(&msg,NULL,0,0);  // this will soak up the keyboard message
													// but you can overwhelm it by keeping the esc key down
					break;
					*/
				}

			//fall thru....
			default:
				if(!IsDialogMessage(hwnd,&msg)) 
				{
					TranslateMessage (&msg) ;
					DispatchMessage (&msg) ;
				}
			break;
		}
	}
    return msg.wParam;
}
char *license ={
"\nCopyright  2009 Greg Spears.\n\n"
"Permission is hereby granted, free of charge, to any person\n"
"obtaining a copy of this software and associated documentation\n"
"files (the \"Software\"), to deal in the Software without restriction,\n"
"including without limitation the rights to use, copy, modify, merge,\n"
"publish, distribute, sublicense, and/or sell copies of the Software,\n"
"and to permit persons to whom the Software is furnished to do so, \n"
"subject to the following conditions:\n"
"\n"
"The above copyright notice and this permission notice shall be\n"
"included in all copies or substantial portions of the Software.\n"
"\n"
"THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF\n"
"ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED\n"
"TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A\n"
"PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT \n"
"SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR\n"
"ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN\n"
"ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
"OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE\n"
"OR OTHER DEALINGS IN THE SOFTWARE.\n\n"};

char *help ={
"\nLogFile Enhancer\n\n"
"Just Drag and Drop a LogFile onto the UI, then click RUN.\n"
"Program will format the LogFile to enhance legibility....\n\n"
"Writes an output html file with same name as source file, but having an 'html' extension.\n\n"
"\nOPTIONS:"
"\n- Enable SQL KeyWord Coloring:   SQL keywords in Blue ---> On/Off  ('Off' makes smaller files..)\n"
"\n- Translate Opaque Strings:    If '&gt;' or '&lt;' appear in text... Do/Don't translate to '>' or '<'.\n"
"   (... leave this box UnChecked to keep logfiles true-to-form).\n"
"\n\n\n"
"Copyright  2009 Greg Spears.  Freeware...enjoy! :-) \n\n"	};

/*------------------------------------------------------------------------------------

WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)

  This is a dialog box procedure but is also the main window.
  The dialgue-box-as-main-window is a great UI...lean, aesthetic.
--------------------------------------------------------------------------------------*/
long APIENTRY WndProc(HWND hWnd, UINT message,UINT wParam, LONG lParam)
{
char sz[200];
static HANDLE hinstIE;

	hWndProc = hWnd;

    switch(message)
	{
    case WM_SYSCOMMAND:
        switch(wParam)
		{
			case IDM_ABOUT:

				sprintf(sz,
				"LogFile Enhancer\n"
				"Version %s \n"
				"Copyright  2009 Greg Spears\n\n",	version);
				MessageBox(hWndDialog,sz, "LogFile About", MB_OK);
				SetFocus(GetDlgItem(hWnd,IDD_RUN_BUTTON));
			return 1;
        
			case IDC_HELP_BUTTON:
				PostMessage(hWnd,WM_COMMAND,IDC_HELP_BUTTON, 0); 
			return 1;
        }
    break;

	case WM_DROPFILES:
		{ 
		HDROP hdrop2 = (HDROP)wParam; // wParam parameter contains the HDROP [1] 

			if(DragQueryFile(hdrop2, 0, szdragdrop, MAX_PATH) > 0) 
				PostMessage(hWnd,WM_COMMAND,IDD_LOAD_FILE,DRAG_N_DROP);
			DragFinish(hdrop2); // Free the resources [3] 
		} 
	return 0;

	case WM_TIMER:
		switch(wParam)
		{
			case DELAYED_STATUS_WAITING_DRAGNDROP: 
				if(!gInProgress)
				{
					SendMessage(hWnd, WM_COMMAND, (WPARAM)(IDD_SET_WAITING_FACE), (LPARAM)0);
					if(infPtr)
						fclose(infPtr);
					SendMessage(GetDlgItem(hWnd,IDD_FILENAME_BOX),WM_SETTEXT,0, (LONG)(LPSTR)"");
					infPtr = NULL;
				}
				KillTimer(hWnd, DELAYED_STATUS_WAITING_DRAGNDROP);
			break;

			case DELAYED_POST_RUN_OPS:
				if(!gInProgress)
				{
					UnWindProgressBar();
					SendMessage(hWnd, WM_COMMAND, (WPARAM)(IDD_SET_INIT_FACE), (LPARAM)0);
				}
				KillTimer(hWnd, DELAYED_POST_RUN_OPS);
			break;

			default:
			break;
		}
	return 1;

	case WM_COMMAND:
        switch(wParam)
		{
			case IDD_GETGOING:

#if GREG_VERSION
				if(!CheckExe(sz))
				{
					MessageBox(NULL, sz, "Error!", MB_ICONEXCLAMATION | MB_OK);
					PostMessage(hWnd,WM_SYSCOMMAND,SC_CLOSE,0L);
				}
#endif //GREG_VERSION

				infPtr = NULL;
				hWndProgressBar = GetDlgItem(hWnd,IDC_PROGRESS);
				SendMessage(hWndProgressBar, PBM_SETRANGE, (WPARAM)0,  MAKELPARAM(0, PROGRESS_MAX_RANGE));      
				SendMessage(hWndProgressBar, PBM_SETSTEP, (WPARAM)1,  (LPARAM)0);      
				SendMessage(hWndProgressBar, PBM_SETBARCOLOR, (WPARAM)0, (LPARAM)RGB(0,255,0));      
				SendMessage(hWnd, WM_COMMAND, (WPARAM)(IDD_SET_WAITING_FACE), (LPARAM)0);

				/* fall thru 1st time ...*/
			case IDD_SET_DEFAULTS: 
				CheckDlgButton(hWndDialog, IDC_ENABLE_SQL_COLOR, 1);	
				CheckDlgButton(hWndDialog, IDC_XLATE_OPAQUE_STRINGS, 0);	
			return 1; 

			case IDD_GETVARS:
				SQL_KeyWord_Color = IsDlgButtonChecked (hWndDialog, IDC_ENABLE_SQL_COLOR);
				translate_opaque_strings = IsDlgButtonChecked (hWndDialog, IDC_XLATE_OPAQUE_STRINGS);
				plain_text = IsDlgButtonChecked (hWndDialog, IDC_PLAIN_TEXT);
				if(plain_text)
				{
					SQL_KeyWord_Color = 0;
					CheckDlgButton(hWndDialog, IDC_ENABLE_SQL_COLOR, 0);
				}
			break;

			case IDD_SET_WAITING_FACE:		
				SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)(0), (LPARAM)0);
				SendMessage(GetDlgItem(hWnd,IDD_STATUS_BOX),WM_SETTEXT,0,
							(LONG)(LPSTR)"Waiting Drag-n-Drop File");
				//MessageBox(NULL, "Waiting Drag-n-Drop File", "Info", MB_OK );
				//GetModuleFileName(NULL, sz, MAX_PATH);
				//MessageBox(NULL, sz, "Info", MB_OK );

			return 1;

			case IDD_SET_INIT_FACE:		
				SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)(0), (LPARAM)0);
				if(infPtr)
					SendMessage(GetDlgItem(hWnd,IDD_STATUS_BOX),WM_SETTEXT,0,(LONG)(LPSTR)"Initialized");
			return 1;

			case IDC_HELP_BUTTON: 
				MessageBox(hWnd, help, "Help", MB_OK );
			break;

			case IDC_LICENSE_BUTTON:
				MessageBox(hWnd, license, "License", MB_OK );
				
			return 1;

			case IDD_RUN_BUTTON:
				SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)(0), (LPARAM)0);
				if(!infPtr )
				{
					SendMessage(GetDlgItem(hWnd,IDD_FILENAME_BOX),WM_SETTEXT,0, (LONG)(LPSTR)"No File");
					return 1;
				}

				/* standard initializations... */
				SendMessage(GetDlgItem(hWnd,IDD_STATUS_BOX),WM_SETTEXT,0,(LONG)(LPSTR)"In Progress");
				gQuitMssg=0;
				gInProgress=1;
				SendMessage(hWnd,WM_COMMAND, IDD_GETVARS,0);

				if(parsefile(hWnd, infPtr, szdragdrop)) /* call the work horse */
				{
				/* de-init ...*/
					SendMessage(GetDlgItem(hWnd,IDD_STATUS_BOX),WM_SETTEXT,0, (LONG)(LPSTR)"Done");
				}
				else
					SendMessage(GetDlgItem(hWnd,IDD_STATUS_BOX),WM_SETTEXT,0, (LONG)(LPSTR)"Error");
				gInProgress=0;
				/* Windback progress bar after X secs */
	            SetTimer(hWnd, DELAYED_POST_RUN_OPS, 1000L, NULL); 
				/* If user is inactive, close file and return to waiting-input state after 60 secs */
	            SetTimer(hWnd, DELAYED_STATUS_WAITING_DRAGNDROP, 60000L, NULL); 
			return 1;

			case IDC_ENABLE_SQL_COLOR:  /* Having this command check-stop actually allows us to enable
										** or diable SQL coloring _during_ file processing ( if you're qwk or
										** having a very large file ) */
				SQL_KeyWord_Color = IsDlgButtonChecked (hWndDialog, IDC_ENABLE_SQL_COLOR);
			return 1;


			case IDD_LOAD_FILE:
				if(infPtr )
					fclose(infPtr);
				SendMessage(GetDlgItem(hWnd,IDD_FILENAME_BOX),WM_SETTEXT,0, (LONG)(LPSTR)"");
				if(lParam == DRAG_N_DROP)
					infPtr = FileOpen( hWnd, szdragdrop);
				if(!infPtr)
				{
					MessageBox(hWnd, "Bad File Load", "ERROR", MB_OK );
					szdragdrop[0]='\0'; 
					return 0;
				}
				SendMessage(hWnd, WM_COMMAND, (WPARAM)(IDD_SET_INIT_FACE), (LPARAM)0);
			return 1; 

			case IDCANCEL:
				gQuitMssg=1;
				if(infPtr && ! gInProgress)
					fclose(infPtr);
				PostMessage(hWnd,WM_SYSCOMMAND,SC_CLOSE,0L);
			return 1;

		}
        break;
    
		case WM_DESTROY:
			gQuitMssg=1;
			PostQuitMessage(0);
        return 0;
    }
    return DefWindowProc(hWnd,message,wParam,lParam);
}




/*----------------------------------------------------
  FileOpen - open a log file
 ----------------------------------------------------*/
FILE * FileOpen( HWND   hWnd, char *szpfilename)
{
char szfname[_MAX_PATH],  sz[50], *ptr;
FILE *infPtr = NULL;

	if(!szpfilename)
			return NULL;

	strcpy(szfname,szpfilename);
	
	infPtr = fopen(szfname, "rb");
	if(!infPtr)
	{int offs = max(0,(int)strlen(szfname)-20);
        sprintf( sz,"Could not open file ...%s", &szfname[offs] );
        MessageBox( hWnd, sz, "OpenFile", MB_ICONEXCLAMATION | MB_OK );
        return NULL;
    }

	/** format string...hack out the path**/
	ptr=szfname + strlen( szfname );
	while(*ptr != '\\' && *ptr != '/' && *ptr != ':' && ptr>szfname)
		ptr--;
	SendMessage(GetDlgItem(hWnd,IDD_FILENAME_BOX),WM_SETTEXT,0,	(LONG)(LPSTR)(ptr+1));

	return infPtr;
}


/*----------------------------------------------------
  UnWind the Progress bar...eye candy for geeks.
  Make the progress bar roll back smoothly after a 
  run
 ----------------------------------------------------*/
void UnWindProgressBar(void)
{
int bar_pos = PROGRESS_MAX_RANGE;
int timet = clock();

	while (bar_pos)
	{
		SpinTheMessageLoop(NULL);
		if(clock() > timet)
		{
			SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)bar_pos--, (LPARAM)0);
	
			//for the unwind to last 1/2 second, say "*0.5"
			timet+=(int)((CLOCKS_PER_SEC/PROGRESS_MAX_RANGE)*0.5); 
		}
	}
}